/**   
* @Package     : com.ccb.mobile.platform.actionflow
* @Copyright   : @版权所有 中国建设银行版权所有
* @Description : 交易流程控制
* @author      : dongguangyu   
* @date        : 2014-8-16
* @version     : v1.0   
*/

package com.ccb.mobile.platform.actionflow;

import java.util.HashMap;
import java.util.StringTokenizer;

import android.R.string;
import android.text.TextUtils;
import android.view.TextureView;

import com.ccb.mobile.platform.PlatformManager;
import com.ccb.mobile.platform.bean.SYS_TXATTR;

/**
 * @author dongguangyu
 *
 */
public class OperationFlow {
	private SYS_TXATTR txAttr;
	private String actionBefore;
	private String actionAfter;
	@SuppressWarnings("rawtypes")
	private HashMap<String,Class> actionBefore_Map = new HashMap<String,Class>();;
	@SuppressWarnings("rawtypes")
	private HashMap<String,Class> actionAfter_Map = new HashMap<String,Class>();
	/**
	 * <p>Title: </p>
	 * <p>Description: </p>
	 */
	public OperationFlow(SYS_TXATTR txAttr) {
		// TODO Auto-generated constructor stub
		this.txAttr = txAttr;
		iniAction();
	}
	
	public void excute(){
		
	}

	protected void iniAction() {
		actionBefore = txAttr.getActionBefore();
		actionAfter = txAttr.getActionAfter();
		
		if(!TextUtils.isEmpty(actionBefore)){
			actionBefore_Map = new HashMap<String, Class>();
			StringTokenizer actionBefore_token = new StringTokenizer(actionBefore,"|");
			while (actionBefore_token.hasMoreElements()) {
				String actionName = (String) actionBefore_token.nextElement();
				String className = "com.ccb.mobile.platform.actionflow."+actionName;
				if(invokeClass(className) != null){
					actionBefore_Map.put(actionName, invokeClass(className));
				}
			}
		}
		if(!TextUtils.isEmpty(actionAfter)){
			actionAfter_Map = new HashMap<String, Class>();
			StringTokenizer actionAfter_token = new StringTokenizer(actionAfter,"|");
			while (actionAfter_token.hasMoreElements()) {
				String actionName = (String) actionAfter_token.nextElement();
				String className = "com.ccb.mobile.platform.actionflow."+actionName;
				if(invokeClass(className) != null){
					actionAfter_Map.put(actionName, invokeClass(className));
				}
			}
		}
	}

	private Class<?> invokeClass(String className){
		if(TextUtils.isEmpty(className)){
			return null;
		}
		try {
			return Class.forName(className);
		} catch (ClassNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			return null;
		}
	}

	/**
	 * @return the actionBefore_Map
	 */
	public HashMap<String, Class> getActionBefore_Map() {
		return actionBefore_Map;
	}

	/**
	 * @param actionBefore_Map the actionBefore_Map to set
	 */
	public void setActionBefore_Map(HashMap<String, Class> actionBefore_Map) {
		this.actionBefore_Map = actionBefore_Map;
	}

	/**
	 * @return the actionAfter_Map
	 */
	public HashMap<String, Class> getActionAfter_Map() {
		return actionAfter_Map;
	}

	/**
	 * @param actionAfter_Map the actionAfter_Map to set
	 */
	public void setActionAfter_Map(HashMap<String, Class> actionAfter_Map) {
		this.actionAfter_Map = actionAfter_Map;
	}
	
	
	
	
	
}
