/**   
* @Package     : com.ccb.mobile.platform.db
* @Copyright   : @版权所有 中国建设银行版权所有
* @Description : 数据库访问类
* @author      : dongguangyu   
* @date        : 2014-4-24
* @version     : v1.0   
*/

package com.ccb.mobile.platform.db;

import com.ccb.mobile.platform.utils.MbsLogManager;

import android.content.Context;
import android.database.sqlite.SQLiteDatabase;
import android.database.sqlite.SQLiteOpenHelper;

public class DBHelper extends SQLiteOpenHelper{

	private static String DB_NAME = "CCB_Platform";
	
	public DBHelper(Context context,int db_version) {
		super(context, DB_NAME, null, db_version);
		MbsLogManager.logD("db_version:"+db_version);
	}

	@Override
	public void onCreate(SQLiteDatabase db) {
		
		
		//创建交易表，请求、返回报文表，系统参数表
		String sys_txattr = "create table if not exists SYS_TXATTR" +
				"(" +
					"TXCODE VARCHAR(110) not null," +
					"TXNAME VARCHAR(120) not null," +
					"CHANNEL_TYPE VARCHAR(100) not null," +
					"SUBMIT_TYPE VARCHAR(106) not null," +
					"CHARACTER_ENCODING VARCHAR(110) not null," +
					"PAKAGE_TYPE VARCHAR(105)," +
					"URL VARCHAR(1768)," +
					"SNPAK VARCHAR(111)," +
					"REVPAK VARCHAR(111)," +
					"ACTION_BEFORE VARCHAR(200)," +
					"ACTION_AFTER VARCHAR(200)" +
				")";
		
		String sys_package = "create table if not exists SYS_PACKAGE" +
				"(" +
					"PAK_ID      VARCHAR(111) not null,  " +
					"TAG_ID      VARCHAR(120) null, "      +   
					"TAG_DES    VARCHAR(130) null, "       +
					"REPLIST     VARCHAR(1256) null,"      +
					"MUSTIN      VARCHAR(101) null, "       +
					"TAG_LENGTH  VARCHAR(104) null "        +
				")";

				
		String sys_para = "create table if not exists SYS_PARAS" +
				"(" +
					"PARA_CODE      VARCHAR(120) not null,"  +
					"PARA_VALUE     VARCHAR(1512) not null," +
					"PARA_DESC      VARCHAR(200),"          +
					"CHANNEL_TYPE   VARCHAR(101) not null"    +
				")";
		db.execSQL(sys_txattr);
		db.execSQL(sys_package);
		db.execSQL(sys_para);
		MbsLogManager.logD("数据库初始化。。。。。");
	}

	@Override
	public void onUpgrade(SQLiteDatabase db, int oldVersion, int newVersion) {
		if(newVersion > oldVersion){
			db.execSQL("drop table sys_txattr");
			db.execSQL("drop table sys_package");
			db.execSQL("drop table sys_paras");
			onCreate(db);
		}
		
	}

}
