/**   
* @Package     : com.ccb.mobile.platform.system
* @Copyright   : @版权所有 中国建设银行版权所有
* @Description : TODO(用一句话描述该文件做什么)
* Administrator   
* 2014-4-25
* @version     : v1.0   
*/

package com.ccb.mobile.platform.system;

import java.util.ArrayList;
import java.util.HashMap;

import org.apache.http.Header;
import org.apache.http.message.BasicNameValuePair;

import android.content.Context;
import android.graphics.Bitmap;
import android.text.TextUtils;
import android.util.Log;

import com.ccb.mobile.platform.bean.AppInfo;
import com.ccb.mobile.platform.http.HttpClient;
import com.ccb.mobile.platform.http.Response;
import com.ccb.mobile.platform.utils.MbsLogManager;

/**
 * @ClassName    : BeseSystem
 * @Description  : TODO(这里用一句话描述这个类的作用)
 * @author       : LiangYJ
 * @date         : 2014-4-25
 * 
 */
public abstract class BaseSystem<T> {
	protected static final String TAG = "CCB_HttpClient";
	protected static final String METHOD_GET = "GET";
	protected static final String METHOD_POST = "POST";
	protected Context mContext;
	protected static HashMap<String, String> mParamsMap;//请求参数
	protected String mBaseUrl="";//交易请求地址
//	public static String ENCODING = "UTF-8";//默认编码方式
	//public static boolean mResposeEncode;//服务端返回编码格式
	public HttpClient httpClient;
	public static AppInfo mAppInfo; //应用版本信息
	public static Header[] responseHeaders;
	
	public BaseSystem(Context context) {
		mContext = context;
	}
	
	/**
	 * 
	* 本地获取缓存数据
	 */
	protected abstract T fectchFromCache();
	
	/**
	 * 
	* 是否缓存数据 
	 */
	protected abstract boolean isCache();
	
	public void setBaseUrl(String url){
		mBaseUrl = url;
	}
	
//	public void setEncoding(String encoding){
//		ENCODING = encoding;
//	}
//	
//	public void setResposeEncode(boolean resposeEncode){
//		mResposeEncode = resposeEncode;
//	}
	
	public HttpClient getHttpClient(final String chartSet){
		if(httpClient == null){
			httpClient = new HttpClient();
		}
		if(!TextUtils.isEmpty(chartSet)){
			httpClient.setChartSet(chartSet);
		}else{
			httpClient.setChartSet(HttpClient.UTF_8);
		}
		httpClient.setHTTP_CONTENT_CHARSET();
		return httpClient;
	}
	public void setHttpClient(HttpClient httpclient){
		this.httpClient = httpclient;
	}
	
	/**
	 *网络请求模块，拼接请求参数。
	* This isBaseSystem.java class 
	* @param url　　请求URL
	* @param params 交易参数
	* @return String: 返回类型
	 */
	public String getParamsUrl(String url,HashMap<String, String> params){
		StringBuilder sb = new StringBuilder();
		int i = 0;
		//URL以问号结束，则拼接请求串时，第一个参数前不加&符号
		boolean url_endTag = false;
		sb.append(url);
		if(url != null && url.trim().endsWith("?")){
			url_endTag = true;
		}
		
		if(params != null && params.size() > 0){
			for (String key : params.keySet()) {
				String value = params.get(key);
				if(i == 0 && url_endTag){
					sb.append(key).append("=").append(value);
				}else{
					sb.append("&").append(key).append("=").append(value);
				}
				i++;
			}
		}
		return sb.toString();
	}
	/**
	 * 
	* 将参数从HashMap<String, String>类型转换成ArrayList<BasicNameValuePair>类型，以便进行网络操作
	 */
	public static ArrayList<BasicNameValuePair> getBasicNameValuePairs(HashMap<String, String> params){
		ArrayList<BasicNameValuePair> list = null;
		if(params != null && !params.isEmpty()){
			list = new ArrayList<BasicNameValuePair>(params.size());
			for (String key : params.keySet()) {
				if(MbsLogManager.IS_DEBUG){
					Log.d(TAG, key + "--" + params.get(key));
				}
				list.add(new BasicNameValuePair(key, params.get(key)));
			}
		}
		return list;
	}
	
	/**
	 * 
	 * @return the responseHeaders
	 */
	public static Header[] getResponseHeaders() {
		return responseHeaders;
	}

	/**
	 * 手机银行系统需要设置保留请求头信息HEAD_SKEY、HEAD_MBSKEY、HEAD_USERID、HEAD_BRANCHID，下支交易发送需要
	 * @param responseHeaders the responseHeaders to set
	 */
	public static void setResponseHeaders(Header[] responseHeaders) {
		BaseSystem.responseHeaders = responseHeaders;
		if(responseHeaders != null){
			setMBSMustPara(responseHeaders);
		}
	}
	
	public static void setMBSMustPara(Header[] responseHeaders){
		for (Header header : responseHeaders) {
			if("HEAD_SKEY".equalsIgnoreCase(header.getName())){
				if(!TextUtils.isEmpty(header.getValue())){
					com.ccb.mobile.platform.Constants.MBS_SKEY = header.getValue();
				}
			}else if("HEAD_MBSKEY".equalsIgnoreCase(header.getName())){
				if(!TextUtils.isEmpty(header.getValue())){
					com.ccb.mobile.platform.Constants.MBS_MBSKEY = header.getValue();
				}
			}else if("HEAD_USERID".equalsIgnoreCase(header.getName())){
				if(!TextUtils.isEmpty(header.getValue())){
					com.ccb.mobile.platform.Constants.MBS_USERID = header.getValue();
				}
			}else if("HEAD_BRANCHID".equalsIgnoreCase(header.getName())){
				if(!TextUtils.isEmpty(header.getValue())){
					com.ccb.mobile.platform.Constants.MBS_BRANCHID = header.getValue();
				}
			}
		}
	}
	/**
	 * 
	* @param params 交易请求参数
	* @return String: 返回类型
	 */
	public String request_String(String url, HashMap<String, String> params,final String chartSet, final boolean isCallISO_GBK){
		return null;
	}
	public Bitmap request_Bitmap(String url, HashMap<String, String> params){
		return null;
	}
	public Response request_VersionManage(String url, HashMap<String, String> params){
		return null;
	}
}
