/**   
 * @Package     : com.ccb.mobile.platform.system
 * @Copyright   : @版权所有 中国建设银行版权所有
 * @Description : TODO(用一句话描述该文件做什么)
 * Administrator   
 * 2014-4-25
 * @version     : v1.0   
 */

package com.ccb.mobile.platform.system;

import java.io.InputStream;
import java.util.HashMap;

import org.apache.http.client.CookieStore;
import org.apache.http.cookie.Cookie;

import android.content.Context;
import android.graphics.Bitmap;
import android.text.TextUtils;

import com.ccb.mobile.platform.Constants;
import com.ccb.mobile.platform.exception.NetworkException;
import com.ccb.mobile.platform.http.HttpClient;
import com.ccb.mobile.platform.http.HttpException;
import com.ccb.mobile.platform.http.Response;
import com.ccb.mobile.platform.utils.MbsLogManager;

/**
 * 生成Ebs(网银)系统,负责处理各种Ebs规则
 * 
 * @ClassName : VersionManageSystem
 * @author : LiangYJ
 * @date : 2014-4-25
 * 
 */
public class VersionManageSystem extends BaseSystem<Object> {
	private static final HashMap<String, String> HEADER = new HashMap<String, String>(
			6);
	private static final String USER_AGENT = "Mozilla/4.0 (compatible; MSIE 8.0; Windows NT 6.1; Trident/4.0; SLCC2; .NET CLR 2.0.50727; .NET CLR 3.5.30729; .NET CLR 3.0.30729; Media Center PC 6.0; InfoPath.2)";
	private static final String ACCEPT = "image/jpeg, application/x-ms-application, image/gif, application/xaml+xml, image/pjpeg, application/x-ms-xbap, application/vnd.ms-excel, application/vnd.ms-powerpoint, application/msword, */*";
	private static final String CONNECTION = "Keep_Alive";
	private static final String ACCEPT_LANGUAGE = "zh-cn,zh;q=0.5";
	private static final String ACCEPT_ENCODING = "gzip, deflate";
	private static final String REFERER = "http://www.ccb.com/cn";
	private static CookieStore mCookieStore;
	private static VersionManageSystem versionManageSystem;

	static {
		HEADER.put("user-agent", USER_AGENT);
		HEADER.put("accept", ACCEPT);
		HEADER.put("Proxy-Connection", CONNECTION);
		HEADER.put("Accept-Language", ACCEPT_LANGUAGE);
		HEADER.put("Accept-Encoding", ACCEPT_ENCODING);
		HEADER.put("Referer", REFERER);
	}

	public VersionManageSystem(Context context) {
		super(context);
	}

	@Override
	protected Bitmap fectchFromCache() {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	protected boolean isCache() {
		// TODO Auto-generated method stub
		return false;
	}

	public static VersionManageSystem getVersionManageSystem(Context context,
			HashMap<String, String> params) {
		if (versionManageSystem == null) {
			versionManageSystem = new VersionManageSystem(context);
		}
		return versionManageSystem;
	}

	/**
	 * 无交易码交易，返回请求串
	 * 
	 * @param params
	 * @return
	 * @return String: 返回类型
	 */
	public String getParamsUrl(String url, HashMap<String, String> params) {
		StringBuilder sb = new StringBuilder();
		int i = 0;
		if (params != null && params.size() > 0) {
			url = params.get("APP_VERSION");
			sb.append(url);
			if (!TextUtils.isEmpty(url) && !url.endsWith("?")) {
				sb.append("?");
			}
			for (String key : params.keySet()) {
				if ("APP_VERSION".equalsIgnoreCase(key)
						|| "Range".equalsIgnoreCase(key)) {
					continue;
				}
				String value = params.get(key);
				if (i == 0) {
					sb.append(key).append("=").append(value);
				} else {
					sb.append("&").append(key).append("=").append(value);
				}
				i++;
			}
		}
		return sb.toString();
	}

	@Override
	public Response request_VersionManage(String url, HashMap<String, String> params) {
		HttpClient httpClient = getHttpClient(null);
		setHttpClient(httpClient);
		// 设置请求头
		HEADER.put("Range", "bytes="+(params.get("Range")));
		httpClient.setHeaders(HEADER);
		// 结果标志
		boolean b = false;
		if (mCookieStore != null) {
			httpClient.setCookie(mCookieStore);
		}
		Response response = null;
		
		try {
			String requetst_url = getParamsUrl(url,params);
			response = httpClient.post(requetst_url);
			b = true;
		} catch (HttpException e) {
			e.printStackTrace();
			b = false;
			throw new NetworkException(Constants.EXCEPTION_NETWORK_ERROR);
		}

		MbsLogManager.logD("VersionManageSystem sendRequestForIo result is "
				+ b);
		return response;

	}

	public static String getCookies() {
		if (mCookieStore == null) {
			return "";
		} else {
			for (Cookie cookie : mCookieStore.getCookies()) {
				if ("CCBIBS1".equals(cookie.getName()))
					return cookie.getValue();
			}
			return "";
		}
	}
}
