/*
 *@Package     :ThreadPools.java
 *@classes     :com.ccb.mobile.android.ThreadPool.ThreadPools 
 *@Copyright   : @版权所有 Administrator
 *@version     : v1.0 
 *Johnli
 */
package com.ccb.mobile.platform.threadpool;

import java.util.concurrent.BlockingQueue;
import java.util.concurrent.Executor;
import java.util.concurrent.LinkedBlockingDeque;
import java.util.concurrent.ThreadFactory;
import java.util.concurrent.ThreadPoolExecutor;
import java.util.concurrent.TimeUnit;

import android.R.integer;

/**
 *@classes     :com.ccb.mobile.android.ThreadPool.ThreadPools 
 *@Description :TODO()
 *@author      :Johnli <br/>
 *create at 2014-7-10 下午2:24:05
 *modify: 内容              by:
 *modify date:日期
 */
public class Platform_ThreadPools {
	 private final static int POOL_SIZE = 4;// 线程池的大小最好设置成为CUP核数的2N  
	    private final static int MAX_POOL_SIZE = 6;// 设置线程池的最大线程数  
	    private final static int KEEP_ALIVE_TIME = 30;// 设置线程的存活时间  
	    private final Executor mExecutor; 
	    private  static Platform_ThreadPools threadPools;
	    private Platform_ThreadPools() {  
	        // 创建线程池工厂  
	        ThreadFactory factory = new Platform_PriorityThreadFactory("thread-pool", android.os.Process.THREAD_PRIORITY_BACKGROUND);  
	        // 创建工作队列  
	        BlockingQueue<Runnable> workQueue = new LinkedBlockingDeque<Runnable>();  
	        mExecutor = new ThreadPoolExecutor(POOL_SIZE, MAX_POOL_SIZE, KEEP_ALIVE_TIME, TimeUnit.SECONDS, workQueue, factory);  
	    }  
	    
	    public static Platform_ThreadPools getInstance(){
	      if (threadPools==null) {
			threadPools = new Platform_ThreadPools();
		  }	
	      return threadPools;
	    }
	    
	    // 在线程池中执行线程  
	    public void submit(Runnable command){  
	        mExecutor.execute(command);  
	    }  
}
